<template>
  <v-row justify="center" no-gutters>
    <v-card style="width: 100%">
      <v-toolbar style="position:relative" color="white" elevation="0">
        <v-spacer />
        <v-toolbar-title class="mt-5">
          <span class="primary--text">
            <v-icon large color="primary" class="mr-2 pb-1">mdi-card-text</v-icon><b>{{ title }}</b>
          </span>
        </v-toolbar-title>
        <v-spacer />
        <v-tooltip color="red" bottom>
          <template v-slot:activator="{ on }">
            <v-icon
              v-on="on"
              style="position:absolute; right: 15px"
              color="red"
              @click="handleClose"
              >mdi-close</v-icon
            >
          </template>
          <span><b>Fechar</b> janela</span>
        </v-tooltip>
      </v-toolbar>
      <!-- Read mode -->
      <div v-if="!editMode" class="scrollForm">
        <section v-for="(item, index) in reply.answers" :key="item._id">
          <v-card-title
            style="position: relative"
            class="buttonHoverTC py-3 mx-5 secondary--text navDrive"
          >
            <div class="styleTC">
              <span class="bold">Título:</span> {{ item.title }}
              <br />
              <span class="bold">Enviado por:</span> {{ showSendBy(item.sendBy) }}
              <br />
              <span class="bold">Data envio: </span>
              <span v-html="compareData(item.sendDate)" />
            </div>
            <span style="position:absolute; bottom: 10px; right:0px">
              <!-- <v-btn small elevation="0" text @click="editAnswer()" disabled>
                <v-icon small class="mr-2">mdi-pencil</v-icon>Editar</v-btn
              > -->
              <v-btn
                v-if="index > 0 && checkPermissions.get('collaborativeWorkDelete')"
                small
                elevation="0"
                class="mr-2"
                text
                @click="deleteAnswer(item)"
              >
                <v-icon small class="mr-2">mdi-delete</v-icon>Deletar</v-btn
              >
            </span>
          </v-card-title>
          <!-- Conteudo messagem -->
          <v-card-text class="px-8 pt-6 pb-6">
            <section>
              <span style="color:rgba(0,0,0,.6)" v-html="item.comment" />
            </section>
          </v-card-text>
          <!-- Anexos -->
          <v-card-text
            v-if="item.files && item.files.length > 0"
            :class="item.files.length > 0 ? 'pt-0 pb-5' : 'pt-0 pb-2'"
          >
            <section style="font-size: 0.95rem">
              <span v-if="item.files && item.files.length > 0 && index == 0">
                <v-icon small>mdi-paperclip</v-icon><b>Anexo:</b>
                <span v-for="(attach, index) in item.files" :key="attach._id">
                  <v-chip
                    v-if="index + 1 == item.files.length"
                    :outlined="hoverAttachment != attach._id"
                    :color="hoverAttachment == attach._id ? 'secondary' : 'primary'"
                    class="ml-1"
                    small
                    @click.stop="downloadAttachment(item._id, attach.name, attach._id)"
                    @mouseenter="hoverAttachment = attach._id"
                    @mouseleave="hoverAttachment = null"
                    >{{ attach.name }}</v-chip
                  >
                  <div
                    v-if="index + 1 == item.files.length"
                    class="ml-4 mt-1"
                    style="font-size: 0.8rem"
                  >
                    <span>Enviado </span>
                    <span v-html="compareData(attach.timestamp)" />
                    <span> por {{ showSendBy(attach.sendBy) }}</span>
                  </div>
                </span>
              </span>
            </section>
          </v-card-text>
          <!-- Fim v-for anexos -->
        </section>
        <!-- Fim v-for respostas/ read Mode-->
      </div>
      <!-- Edit mode -->
      <div v-else class="scrollForm">
        <FormatedMessage
          :editing="editing"
          :buttonLabel="buttonLabel"
          :addEditMode="addEditMode"
          @cancelReply="cancelReply"
          @sendedMsg="confirm"
        />
      </div>
      <!-- Botão Fechar -->
      <v-card-actions v-if="!editMode" class="mt-n3 pb-6 pr-6">
        <v-spacer />
        <v-btn color="lighter" text @click="handleClose">Fechar</v-btn>
        <v-btn color="primary" elevation="0" @click="replyAnswer">Responder</v-btn>
      </v-card-actions>
    </v-card>
    <!-- Confirma deletar-->
    <AlertConfirm
      :alert="alert"
      @clickCancelAlert="alert.status = false"
      @clickConfirmAlert="deleteReply"
    />
  </v-row>
</template>

<script>
import FormatedMessage from '@/components/FormatedMessage.vue'
import { Utils } from '../../utils/utils'
import CollaborativeWork from '../../services/collaborativeWork'
import Management from '../../services/management'
export default {
  name: 'ReadReply',
  props: {
    reply: { type: Object, default: {} },
    collaborativeWorkAnswerId: { type: String },
    availableUsers: {
      type: Array,
      default: () => {
        return []
      },
    },
  },
  components: {
    FormatedMessage,
  },
  data: () => ({
    hoverAttachment: null,
    menu: false,
    selectedReply: -1,
    editMode: false,
    title: 'Exibindo Respostas',
    buttonLabel: '',
    editing: {},
    userLogged: {},
    itemToDelete: '',
    addEditMode: '',
    alert: {
      status: false,
      itemName: '',
      message: 'Você deseja <b>deletar</b> a resposta?',
      messageOk: 'Sim',
      messageCancel: 'Não',
    },
  }),

  computed: {
    checkDialogIsActive() {
      return this.$store.state.user.closeDialog
    },
    checkPermissions() {
      // usar checkPermissions.get('nome da permissão')
      return this.$store.state.user.mappedActions
    },
  },
  watch: {
    checkDialogIsActive() {
      if (this.checkDialogIsActive) {
        this.handleClose()
        this.cancelReply()
        this.$store.commit('user/UPDATE_CLOSE_DIALOG', false)
      }
    },
  },
  async created() {
    const userInfo = await this.$getItem('userInfo')
    this.userLogged = userInfo
  },
  methods: {
    compareData(timestamp) {
      return Utils.compareDate(timestamp)
    },
    showSendBy(id) {
      let user
      this.reply.participants.forEach((item) => {
        if (item.user.id === id) user = item.user
      })
      if (!user) {
        this.availableUsers.forEach((data) => {
          if (data.id == id) user = data
        })
      }
      return `${user.name} ${user.surname}`
    },
    downloadAttachment(idAnswer, name, idFile) {
      // console.log(`id da resposta: ${idAnswer}`)
      // console.log(`inicia o download de id: ${idFile} e nome: ${name}`)
      this.downloadAttach(this.collaborativeWorkAnswerId, this.reply._id, idAnswer, idFile, name)
    },
    handleClose() {
      this.$emit('closeMessage')
      this.editMode = false
    },
    replyAnswer() {
      this.$store.commit('user/UPDATE_LOADING', true)
      setTimeout(() => {
        this.editMode = true
        this.title = 'Responder'
        this.buttonLabel = 'Enviar Resposta'
        this.$store.commit('user/UPDATE_LOADING', false)
      }, 250)
    },
    selectReply(item) {
      this.selectedReply = item
    },

    //método ao cancelar o modo "editar/responder"
    cancelReply() {
      this.$store.commit('user/UPDATE_LOADING', true)
      setTimeout(() => {
        this.editing = {}
        this.editMode = false
        this.title = 'Exibindo Respostas'
        this.selectedReply = -1
        this.$store.commit('user/UPDATE_LOADING', false)
      }, 250)
    },
    editAnswer(item) {
      this.$store.commit('user/UPDATE_LOADING', true)
      setTimeout(() => {
        if (item == null) {
          this.editing = this.reply
        } else {
          this.editing = this.reply.answer[item]
        }
        this.editMode = true
        this.title = 'Editar Resposta'
        this.buttonLabel = 'Editar'
        this.$store.commit('user/UPDATE_LOADING', false)
      }, 250)
    },
    deleteAnswer(item) {
      this.alert.status = true
      this.itemToDelete = item._id
    },
    async confirm(item) {
      console.log('recebeu essa resposta', item)
      const routedEntity = await this.$getItem('routedEntity')
      const role = routedEntity.privileges.label
      let reply = {
        collaborativeWorkAnswerId: this.collaborativeWorkAnswerId,
        teamId: this.reply._id,
        answerId: this.reply.answers[0]._id,
        answer: { title: item.title, comment: item.message },
        userLabel: role,
      }
      this.replyAnswerBackend(reply)
    },

    //backend

    async replyAnswerBackend(reply) {
      let ret
      try {
        this.$store.commit('user/UPDATE_LOADING', true)

        const routedEntity = await this.$getItem('routedEntity')
        const actionsMap = this.$store.state.user.mappedActions
        const actionId = actionsMap.get('collaborativeWorkAnswerCreate').id

        ret = await CollaborativeWork.replyAnswer(routedEntity.id, actionId, reply)

        if (ret.success) {
          console.log(ret, 'o que encontra ao responder')
          this.handleClose()
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Resposta <b>enviada</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
          this.$emit('refreshAnswers')
        } else {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Desculpe não foi possível enviar a <b>resposta</b>!',
            icon: 'mdi-close-circle',
            color: 'red',
          })
        }
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
      return ret
    },

    async deleteReply() {
      this.alert.status = false
      let id = this.itemToDelete
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        const routedEntity = await this.$getItem('routedEntity')
        const actionsMap = this.$store.state.user.mappedActions
        const actionId = actionsMap.get('collaborativeWorkDelete').id

        const ret = await CollaborativeWork.deleteAnswer(routedEntity.id, actionId, {
          answer: id, // id resposta a ser deletada
          teamId: this.reply._id, //id time
          answerId: this.collaborativeWorkAnswerId, // id resposta trabalho colaborativo
        })
        if (ret.success) {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: `A <b>resposta</b> foi <b>deletada</b> com sucesso!`,
            icon: 'mdi-check-circle',
            color: 'green',
          })
          if (this.reply.answers.length == 1) this.handleClose()
          this.$emit('refreshAnswers')
        } else {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: `Desculpe, não foi possível deletar a <b>resposta</b>.`,
            icon: 'mdi-close-circle',
            color: 'red',
          })
        }
      } catch (Error) {
        console.log('TCL: deleteCollaborativeWork -> Error', Error)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    async downloadAttach(collaborativeWorkAnswerId, teamId, answerId, fileId, fileName) {
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        const routedEntity = await this.$getItem('routedEntity')
        const actionsMap = this.$store.state.user.mappedActions
        const actionId = actionsMap.get('collaborativeWorkReadAllAvailable').id

        const ret = await CollaborativeWork.downloadFileAnswer(
          routedEntity.id,
          actionId,
          {
            collaborativeWorkAnswerId: collaborativeWorkAnswerId, // id resposta a ser deletada
            teamId: teamId, //id time
            answerId: answerId, // id resposta trabalho colaborativo
            fileId: fileId,
          },
          fileName
        )
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },
  },
}
</script>

<style>
.bold {
  font-weight: 501;
}
.styleTC {
  font-size: 1rem;
  font-weight: 300;
  line-height: 1.35rem;
}
.hoverReply > .v-icon:hover {
  color: #ffc107 !important;
}
.menuOn {
  animation: menuAppears 0.5s;
}

@keyframes menuAppears {
  from {
    transform: translateY(-35px);
    opacity: 0;
  }

  to {
    transform: translateY(0);
    opacity: 1;
  }
}
.buttonHoverTC > span > .v-btn:hover {
  background: #2a0845 !important;
  color: white !important;
}
</style>
